'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _graphqlCompose = require('graphql-compose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AwsParam = function () {
  function AwsParam() {
    (0, _classCallCheck3.default)(this, AwsParam);
  }

  (0, _createClass3.default)(AwsParam, null, [{
    key: 'convertInputStructure',
    value: function convertInputStructure(param, name, shapes) {
      var _this = this;

      var fields = {};

      if (param.members) {
        Object.keys(param.members).forEach(function (fname) {
          fields[fname] = _this.convertParam(param.members[fname], `${name}${(0, _graphqlCompose.upperFirst)(fname)}`, true, shapes);
        });
      }

      var itc = _graphqlCompose.InputTypeComposer.create({
        name: `${name}Input`,
        fields
      });

      if (Array.isArray(param.required)) {
        itc.makeRequired(param.required);
      }

      return itc;
    }
  }, {
    key: 'convertOutputStructure',
    value: function convertOutputStructure(param, name, shapes) {
      var _this2 = this;

      var fields = {};

      if (param.members) {
        Object.keys(param.members).forEach(function (fname) {
          fields[fname] = _this2.convertParam(param.members[fname], `${name}${(0, _graphqlCompose.upperFirst)(fname)}`, false, shapes);
        });
      }

      var tc = _graphqlCompose.TypeComposer.create({
        name,
        fields
      });

      if (Array.isArray(param.required)) {
        tc.makeFieldNonNull(param.required);
      }

      return tc;
    }
  }, {
    key: 'convertParam',
    value: function convertParam(param, name, isInput, shapes) {
      if (param.type) {
        switch (param.type) {
          case 'boolean':
            return 'Boolean';
          case 'string':
            return 'String';
          case 'integer':
            return 'Int';
          case 'float':
            return 'Float';
          case 'timestamp':
            return 'Date';
          case 'structure':
            {
              var tc = isInput ? this.convertInputStructure(param, name, shapes) : this.convertOutputStructure(param, name, shapes);
              // If bugous structure without fields, then return JSON
              if (Object.keys(tc.getFields()).length === 0) {
                return 'JSON';
              }
              return tc;
            }
          case 'map':
            return 'JSON';
          case 'list':
            // $FlowFixMe
            return [this.convertParam(param.member, name, isInput, shapes)];
          default:
            return 'JSON';
        }
      }
      if (param.shape) {
        return this.convertShape(param, isInput, shapes);
      }

      return 'String';
    }
  }, {
    key: 'convertShape',
    value: function convertShape(param, isInput, shapes) {
      if (shapes) {
        return isInput ? shapes.getInputShape(param.shape) : shapes.getOutputShape(param.shape);
      }
      return 'JSON';
    }
  }]);
  return AwsParam;
}();

exports.default = AwsParam;