'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _graphqlCompose = require('graphql-compose');

var _AwsServiceMetadata = require('./AwsServiceMetadata');

var _AwsServiceMetadata2 = _interopRequireDefault(_AwsServiceMetadata);

var _AwsServiceOperation = require('./AwsServiceOperation');

var _AwsServiceOperation2 = _interopRequireDefault(_AwsServiceOperation);

var _AwsShapes = require('./AwsShapes');

var _AwsShapes2 = _interopRequireDefault(_AwsShapes);

var _AwsConfigITC = require('./types/AwsConfigITC');

var _AwsConfigITC2 = _interopRequireDefault(_AwsConfigITC);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AwsService = function () {
  function AwsService(opts) {
    (0, _classCallCheck3.default)(this, AwsService);

    this.prefix = opts.prefix;
    this.serviceId = opts.serviceId;
    this.awsSDK = opts.awsSDK;
    this.config = opts.config;

    this.metadata = new _AwsServiceMetadata2.default(this.config.metadata);
    this.shapes = new _AwsShapes2.default(this.config.shapes, this.getTypeName());
  }

  (0, _createClass3.default)(AwsService, [{
    key: 'getTypeName',
    value: function getTypeName() {
      return `${this.prefix}${(0, _graphqlCompose.upperFirst)(this.serviceId)}`;
    }
  }, {
    key: 'getOperationNames',
    value: function getOperationNames() {
      return Object.keys(this.config.operations);
    }
  }, {
    key: 'getOperation',
    value: function getOperation(name) {
      var operConfig = this.config.operations[name];
      if (!operConfig) {
        throw new Error(`Operation with name ${name} does not exist.`);
      }
      return new _AwsServiceOperation2.default({
        serviceId: this.serviceId,
        name: this.constructor.lowerFirst(name),
        prefix: this.prefix,
        config: operConfig,
        shapes: this.shapes,
        awsSDK: this.awsSDK
      });
    }
  }, {
    key: 'getTypeComposer',
    value: function getTypeComposer() {
      var _this = this;

      if (!this.tc) {
        var fields = this.getOperationNames().reduce(function (res, name) {
          res[_this.constructor.lowerFirst(name)] = _this.getOperation(name).getFieldConfig();
          return res;
        }, {});

        this.tc = _graphqlCompose.TypeComposer.create({
          name: this.getTypeName(),
          fields,
          description: this.metadata.getDescription()
        });
      }
      return this.tc;
    }
  }, {
    key: 'getType',
    value: function getType() {
      return this.getTypeComposer().getType();
    }
  }, {
    key: 'getFieldConfig',
    value: function getFieldConfig() {
      return {
        type: this.getType(),
        args: {
          config: {
            type: _AwsConfigITC2.default.getType(),
            description: 'Will override default configs for aws-sdk.'
          }
        },
        resolve: function resolve(source, args) {
          return {
            awsConfig: (0, _extends3.default)({}, source && source.awsConfig, args && args.config)
          };
        }
      };
    }
  }], [{
    key: 'lowerFirst',
    value: function lowerFirst(name) {
      return name.charAt(0).toLowerCase() + name.slice(1);
    }
  }]);
  return AwsService;
}();

exports.default = AwsService;