'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _graphqlCompose = require('graphql-compose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AwsServiceMetadata = function () {
  function AwsServiceMetadata(metadata) {
    (0, _classCallCheck3.default)(this, AwsServiceMetadata);

    this.metadata = metadata;
  }

  (0, _createClass3.default)(AwsServiceMetadata, [{
    key: 'getPrefix',
    value: function getPrefix() {
      return `Aws${(0, _graphqlCompose.upperFirst)(this.metadata.endpointPrefix)}`;
    }
  }, {
    key: 'getDescription',
    value: function getDescription() {
      // { apiVersion: '2006-03-01',
      //   checksumFormat: 'md5',
      //   endpointPrefix: 's3',
      //
      //   globalEndpoint: 's3.amazonaws.com',
      //   protocol: 'rest-xml',
      //   serviceAbbreviation: 'Amazon S3',
      //   serviceFullName: 'Amazon Simple Storage Service',
      //   serviceId: 'S3',
      //   signatureVersion: 's3',
      //   timestampFormat: 'rfc822',
      //   uid: 's3-2006-03-01' }
      var _metadata = this.metadata,
          serviceFullName = _metadata.serviceFullName,
          apiVersion = _metadata.apiVersion;

      return `${serviceFullName} (${apiVersion})`;
    }
  }, {
    key: 'getTypeComposer',
    value: function getTypeComposer() {
      if (!this.tc) {
        this.tc = _graphqlCompose.TypeComposer.create(`
        type ${this.getPrefix()}Metadata {
          apiVersion: String
          endpointPrefix: String
          globalEndpoint: String
          serviceAbbreviation: String
          serviceFullName: String
          signatureVersion: String
          uid: String
          raw: JSON
        }
      `);
      }
      return this.tc;
    }
  }, {
    key: 'getFieldConfig',
    value: function getFieldConfig() {
      var _this = this;

      return {
        type: this.getTypeComposer().getType(),
        resolve: function resolve() {
          return (0, _extends3.default)({}, _this.metadata, {
            raw: _this.metadata
          });
        }
      };
    }
  }]);
  return AwsServiceMetadata;
}();

exports.default = AwsServiceMetadata;