'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _graphqlCompose = require('graphql-compose');

var _AwsParam = require('./AwsParam');

var _AwsParam2 = _interopRequireDefault(_AwsParam);

var _AwsConfigITC = require('./types/AwsConfigITC');

var _AwsConfigITC2 = _interopRequireDefault(_AwsConfigITC);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AwsServiceOperation = function () {
  function AwsServiceOperation(opts) {
    (0, _classCallCheck3.default)(this, AwsServiceOperation);

    this.prefix = opts.prefix;
    this.name = opts.name;
    this.serviceId = opts.serviceId;
    this.awsSDK = opts.awsSDK;
    this.config = opts.config;
    this.shapes = opts.shapes;
  }

  (0, _createClass3.default)(AwsServiceOperation, [{
    key: 'getTypeName',
    value: function getTypeName() {
      return `${this.prefix}${(0, _graphqlCompose.upperFirst)(this.serviceId)}${(0, _graphqlCompose.upperFirst)(this.name)}`;
    }
  }, {
    key: 'getType',
    value: function getType() {
      if (this.config.output && this.config.output.type === 'structure') {
        var tc = _AwsParam2.default.convertOutputStructure(this.config.output, `${this.getTypeName()}Output`, this.shapes);

        // If bugous structure without fields, then return JSON
        if (Object.keys(tc.getFields()).length === 0) {
          return _graphqlCompose.GraphQLJSON;
        }

        return tc.getType();
      }

      return _graphqlCompose.GraphQLJSON;
    }
  }, {
    key: 'getArgs',
    value: function getArgs() {
      if (!this.args) {
        if (!this.config.input) {
          this.args = {};
        } else {
          var itc = _AwsParam2.default.convertInputStructure(this.config.input, this.getTypeName(), this.shapes);

          var type = void 0;
          // If bugous structure without fields, then return JSON
          if (Object.keys(itc.getFields()).length === 0) {
            type = _graphqlCompose.GraphQLJSON;
          } else {
            var hasRequiredFields = itc.getFieldNames().some(function (f) {
              return itc.isRequired(f);
            });
            type = hasRequiredFields ? itc.getTypeAsRequired() : itc.getType();
          }

          this.args = {
            input: {
              type
            }
          };
        }

        this.args.config = {
          type: _AwsConfigITC2.default.getType()
        };
      }

      return this.args;
    }
  }, {
    key: 'getResolve',
    value: function getResolve() {
      var _this = this;

      return function (source, args) {
        return new Promise(function (resolve, reject) {
          var awsConfig = (0, _extends3.default)({}, source && source.awsConfig, args && args.config);
          var service = new _this.awsSDK[_this.serviceId](awsConfig);
          service[_this.name](args.input, function (err, data) {
            if (err) {
              reject(err);
            }
            resolve(data);
          });
        });
      };
    }
  }, {
    key: 'getFieldConfig',
    value: function getFieldConfig() {
      return {
        type: this.getType(),
        args: this.getArgs(),
        resolve: this.getResolve()
      };
    }
  }]);
  return AwsServiceOperation;
}();

exports.default = AwsServiceOperation;