'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('graphql-compose');

var _AwsParam = require('./AwsParam');

var _AwsParam2 = _interopRequireDefault(_AwsParam);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AwsShapes = function () {
  function AwsShapes(shapes, prefix) {
    (0, _classCallCheck3.default)(this, AwsShapes);

    this.shapes = shapes;
    this.prefix = prefix;
    this.shapesInput = {};
    this.shapesOutput = {};
  }

  (0, _createClass3.default)(AwsShapes, [{
    key: 'getInputShape',
    value: function getInputShape(name) {
      if (!this.shapesInput[name]) {
        if (!this.shapes[name]) {
          throw new Error(`Shape with name '${name}' not found in service config ${this.prefix}`);
        }

        // store firstly as JSON, for solving recursion calls
        this.shapesInput[name] = 'JSON';
        this.shapesInput[name] = _AwsParam2.default.convertParam(this.shapes[name], `${this.prefix}${name}`, true, this);
      }

      return this.shapesInput[name];
    }
  }, {
    key: 'getOutputShape',
    value: function getOutputShape(name) {
      if (!this.shapesOutput[name]) {
        if (!this.shapes[name]) {
          throw new Error(`Shape with name '${name}' not found in service config ${this.prefix}`);
        }

        // store firstly as JSON, for solving recursion calls
        this.shapesOutput[name] = 'JSON';
        this.shapesOutput[name] = _AwsParam2.default.convertParam(this.shapes[name], `${this.prefix}${name}`, false, this);
      }

      return this.shapesOutput[name];
    }
  }]);
  return AwsShapes;
}();

exports.default = AwsShapes;