'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.getTypeName = getTypeName;
exports.getOrSetType = getOrSetType;
exports.desc = desc;
exports.reorderKeys = reorderKeys;

var _typeStorage = require('./typeStorage');

var _typeStorage2 = _interopRequireDefault(_typeStorage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getTypeName(name, opts) {
  return `${opts && opts.prefix || 'Elastic'}${name}${opts && opts.postfix || ''}`;
}

function getOrSetType(typeName, typeOrThunk) {
  var type = _typeStorage2.default.getOrSet(typeName, typeOrThunk);
  return type;
}

// Remove newline multiline in descriptions
function desc(str) {
  return str.replace(/\n\s+/gi, ' ').replace(/^\s+/, '');
}

function reorderKeys(obj, names) {
  var orderedFields = {};
  var fields = (0, _extends3.default)({}, obj);
  names.forEach(function (name) {
    if (fields[name]) {
      orderedFields[name] = fields[name];
      delete fields[name];
    }
  });
  return (0, _extends3.default)({}, orderedFields, fields);
}